# BDF2MCPack

BDF2MCPack is a CLI application to convert a BDF type font file to a resource
pack for Minecraft.  
The application requires Python 3.7 or above.

## Installation

### Windows, Linux and MacOS

Use [pip](https://pip.pypa.io/en/stable/installation/) to install the module
from this repository.
```sh
pip install git+https://github.com/takejohn/BDF2MCPack.git
```

Make sure that the executable file (`bdf2mcpack.exe` or `bdf2mcpack`) is
installed under a directory which is set in the `PATH` environment variable.

## Usage

### Help Message
```
usage: bdf2mcpack [-h] [-o output] [--format FORMAT] [--description DESCRIPTION]
                  [--compresslevel {0,1,2,3,4,5,6,7,8,9}] [--range [RANGE ...]]
                  input

Creates a resource pack for Minecraftfrom a BDF type file.

positional arguments:
  input                 The filename of the BDF file to load

options:
  -h, --help            show this help message and exit
  -o output             The Filename of the resource pack to create (default:
                        pack.zip)
  --format FORMAT, -f FORMAT
                        The value to set as pack.pack_format in pack.mcmeta
                        (default: 18)
  --description DESCRIPTION, -d DESCRIPTION
                        The text to set as pack.description in pack.mcmeta
                        (default: "Generated by bdf2mcpack")
  --compresslevel {0,1,2,3,4,5,6,7,8,9}, -c {0,1,2,3,4,5,6,7,8,9}
                        The compression level used when writing the output file
                        (default: 6)
  --range [RANGE ...], -r [RANGE ...]
                        The Unicode codepoint range to use. Accepts decimal or
                        hexadecimal expressions of codepoints. Case insensitive.
                        e.g. 0-127 U+100000-U+10FFFF
```

### Example

This example downloads [Unifont](https://unifoundry.com/unifont/index.html)
Japanese BDF Version, and creates a resource pack to replace ideographic
Chinese Characters with Japanese Kanji.
```sh
curl -O https://unifoundry.com/pub/unifont/unifont-15.1.04/font-builds/unifont_jp-15.1.04.bdf.gz
gunzip unifont_jp-15.1.04.bdf.gz
bdf2mcpack unifont_jp-15.1.04.bdf -o kanji.zip -r U+4E00-U+9FFF
```

## Used Libraries

* [bdfparser](https://github.com/tomchen/bdfparser)
* [Pillow](https://github.com/python-pillow/Pillow)

## License

This program is distributed under Apache-2.0 license.  
See [`/LICENSE`](/LICENSE) for detail.
